(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/animations'), require('@angular/common'), require('@angular/platform-browser/animations')) :
    typeof define === 'function' && define.amd ? define('bootstrap-toast', ['exports', '@angular/core', '@angular/animations', '@angular/common', '@angular/platform-browser/animations'], factory) :
    (global = global || self, factory(global['bootstrap-toast'] = {}, global.ng.core, global.ng.animations, global.ng.common, global.ng.platformBrowser.animations));
}(this, (function (exports, core, animations, common, animations$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/models/toast.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Toast = /** @class */ (function () {
        function Toast(component, data) {
            this.component = component;
            this.data = data;
        }
        return Toast;
    }());
    if (false) {
        /** @type {?} */
        Toast.prototype.component;
        /** @type {?} */
        Toast.prototype.data;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/bootstrap-toast.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BootstrapToastService = /** @class */ (function () {
        function BootstrapToastService(componentFactoryResolver) {
            this.componentFactoryResolver = componentFactoryResolver;
        }
        /**
         * @param {?} viewContainerRef
         * @param {?} component
         * @return {?}
         */
        BootstrapToastService.prototype.init = /**
         * @param {?} viewContainerRef
         * @param {?} component
         * @return {?}
         */
        function (viewContainerRef, component) {
            this.toasts = viewContainerRef;
            this.component = component;
        };
        /**
         * @param {?} message
         * @return {?}
         */
        BootstrapToastService.prototype.create = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            /** @type {?} */
            var toast = new Toast(this.component, {
                title: null,
                body: message,
                createdAt: (new Date()).getTime(),
                autoClose: true
            });
            /** @type {?} */
            var componentFactory = this.componentFactoryResolver.resolveComponentFactory(toast.component);
            /** @type {?} */
            var componentRef = this.toasts.createComponent(componentFactory);
            (componentRef.instance).data = __assign({}, toast.data, { viewRef: componentRef.hostView });
        };
        /**
         * @param {?} toastItemRef
         * @return {?}
         */
        BootstrapToastService.prototype.remove = /**
         * @param {?} toastItemRef
         * @return {?}
         */
        function (toastItemRef) {
            this.toasts.remove(this.toasts.indexOf(toastItemRef));
        };
        BootstrapToastService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        BootstrapToastService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver }
        ]; };
        /** @nocollapse */ BootstrapToastService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function BootstrapToastService_Factory() { return new BootstrapToastService(core.ɵɵinject(core.ComponentFactoryResolver)); }, token: BootstrapToastService, providedIn: "root" });
        return BootstrapToastService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        BootstrapToastService.prototype.toasts;
        /**
         * @type {?}
         * @private
         */
        BootstrapToastService.prototype.component;
        /**
         * @type {?}
         * @private
         */
        BootstrapToastService.prototype.componentFactoryResolver;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/notification/notification.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NotificationComponent = /** @class */ (function () {
        function NotificationComponent(toastService) {
            this.toastService = toastService;
            this.isClosed = false;
            this.elapsedMinutes = 0;
            this.progressBarStarted = false;
            this.seconds = 3.5;
        }
        /**
         * @return {?}
         */
        NotificationComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.data.autoClose) {
                this.interval = setInterval((/**
                 * @return {?}
                 */
                function () {
                    _this.onClose();
                }), this.seconds * 1000);
            }
            else {
                this._setElapsedMinutes();
                this.interval = setInterval((/**
                 * @return {?}
                 */
                function () {
                    _this._setElapsedMinutes();
                }), 1000);
            }
        };
        /**
         * @return {?}
         */
        NotificationComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            clearInterval(this.interval);
        };
        /**
         * @return {?}
         */
        NotificationComponent.prototype.onClose = /**
         * @return {?}
         */
        function () {
            this.isClosed = true;
        };
        /**
         * @return {?}
         */
        NotificationComponent.prototype.onRemove = /**
         * @return {?}
         */
        function () {
            if (this.isClosed) {
                this.toastService.remove(this.data.viewRef);
            }
        };
        /**
         * @return {?}
         */
        NotificationComponent.prototype.onStartProgressBar = /**
         * @return {?}
         */
        function () {
            this.progressBarStarted = true;
        };
        /**
         * @private
         * @return {?}
         */
        NotificationComponent.prototype._setElapsedMinutes = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var now = +new Date();
            /** @type {?} */
            var created = +new Date(this.data.createdAt);
            this.elapsedMinutes = (new Date(now - created)).getMinutes();
        };
        NotificationComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-notification',
                        template: "<div \n    class=\"toast\"\n    role=\"alert\"\n    aria-live=\"assertive\"\n    aria-atomic=\"true\"\n    [@close-toast]=\"!isClosed ? 'open' : 'close'\"\n    [@open-toast]=\"'open'\"\n    (@close-toast.done)=\"onRemove()\"\n    (@open-toast.done)=\"onStartProgressBar()\">\n    <div class=\"toast-header\">\n        <img *ngIf=\"data.icon\"  [src]=\"data.icon\" class=\"icon rounded mr-2\" alt=\"Toast icon\">\n        <strong class=\"mr-auto\">{{ data.title || 'Message' }}</strong>\n        <small \n            *ngIf=\"elapsedMinutes > 0\" \n            class=\"text-muted\">{{ elapsedMinutes }} mins ago</small>\n        <button \n            type=\"button\"\n            class=\"ml-2 mb-1 close\"\n            (click)=\"onClose()\" \n            data-dismiss=\"toast\"\n            aria-label=\"Close\">\n        <span aria-hidden=\"true\">&times;</span>\n        </button>\n    </div>\n    <div class=\"toast-body\">\n        {{ data.body }}\n    </div>\n    <div class=\"toast-progress-bar\" *ngIf=\"data.autoClose\" >\n        <div class=\"progress\">\n            <div class=\"progress-bar\" role=\"progressbar\" [@progress-bar]=\"progressBarStarted ? 'progress' : ''\" ></div>\n        </div>\n    </div>\n</div>",
                        animations: [
                            animations.trigger('close-toast', [
                                animations.state('close', animations.style({ opacity: 0 })),
                                animations.transition('* => close', [
                                    animations.animate('0.5s')
                                ])
                            ]),
                            animations.trigger('open-toast', [
                                animations.state('open', animations.style({ right: 0 })),
                                animations.transition('* => open', [
                                    animations.animate('0.5s ease-out')
                                ])
                            ]),
                            animations.trigger('progress-bar', [
                                animations.state('progress', animations.style({ width: '100%' })),
                                animations.transition('* => progress', [
                                    animations.animate('3s')
                                ])
                            ])
                        ],
                        styles: [".toast{position:relative;right:-350px;opacity:1;margin:25px;min-width:320px;max-width:320px}.toast .icon{width:18px;height:auto}.toast .progress{height:2px;border-radius:0!important;background-color:transparent}"]
                    }] }
        ];
        /** @nocollapse */
        NotificationComponent.ctorParameters = function () { return [
            { type: BootstrapToastService }
        ]; };
        NotificationComponent.propDecorators = {
            data: [{ type: core.Input }]
        };
        return NotificationComponent;
    }());
    if (false) {
        /** @type {?} */
        NotificationComponent.prototype.data;
        /** @type {?} */
        NotificationComponent.prototype.isClosed;
        /** @type {?} */
        NotificationComponent.prototype.elapsedMinutes;
        /** @type {?} */
        NotificationComponent.prototype.progressBarStarted;
        /**
         * @type {?}
         * @private
         */
        NotificationComponent.prototype.interval;
        /**
         * @type {?}
         * @private
         */
        NotificationComponent.prototype.seconds;
        /**
         * @type {?}
         * @private
         */
        NotificationComponent.prototype.toastService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/toast.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastDirective = /** @class */ (function () {
        function ToastDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        ToastDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[lib-bootstrap-toast-host]'
                    },] }
        ];
        /** @nocollapse */
        ToastDirective.ctorParameters = function () { return [
            { type: core.ViewContainerRef }
        ]; };
        return ToastDirective;
    }());
    if (false) {
        /** @type {?} */
        ToastDirective.prototype.viewContainerRef;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/bootstrap-toast.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BootstrapToastComponent = /** @class */ (function () {
        function BootstrapToastComponent(service) {
            this.service = service;
        }
        /**
         * @return {?}
         */
        BootstrapToastComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.service.init(this.toastHost.viewContainerRef, NotificationComponent);
        };
        BootstrapToastComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-bootstrap-toast',
                        template: "\n    <div class=\"notifications\">\n        <ng-template lib-bootstrap-toast-host></ng-template>\n    </div>\n  ",
                        styles: ["\n    .notifications {\n        position: fixed;\n        top: 0px;\n        right: 0px;\n        height: auto;\n    }\n    "]
                    }] }
        ];
        /** @nocollapse */
        BootstrapToastComponent.ctorParameters = function () { return [
            { type: BootstrapToastService }
        ]; };
        BootstrapToastComponent.propDecorators = {
            toastHost: [{ type: core.ViewChild, args: [ToastDirective, { static: true },] }]
        };
        return BootstrapToastComponent;
    }());
    if (false) {
        /** @type {?} */
        BootstrapToastComponent.prototype.toastHost;
        /**
         * @type {?}
         * @private
         */
        BootstrapToastComponent.prototype.service;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/bootstrap-toast.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BootstrapToastModule = /** @class */ (function () {
        function BootstrapToastModule() {
        }
        BootstrapToastModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            BootstrapToastComponent,
                            ToastDirective,
                            NotificationComponent
                        ],
                        imports: [
                            common.CommonModule,
                            animations$1.BrowserAnimationsModule
                        ],
                        entryComponents: [
                            NotificationComponent
                        ],
                        exports: [
                            BootstrapToastComponent
                        ]
                    },] }
        ];
        return BootstrapToastModule;
    }());

    exports.BootstrapToastComponent = BootstrapToastComponent;
    exports.BootstrapToastModule = BootstrapToastModule;
    exports.BootstrapToastService = BootstrapToastService;
    exports.ɵa = ToastDirective;
    exports.ɵb = NotificationComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bootstrap-toast.umd.js.map
