import { BootstrapToastService } from './../bootstrap-toast.service';
import { OnInit, OnDestroy } from '@angular/core';
import { Notification } from '../models/notification';
export declare class NotificationComponent implements OnInit, OnDestroy {
    private toastService;
    data: Notification;
    isClosed: boolean;
    elapsedMinutes: number;
    progressBarStarted: boolean;
    private interval;
    private seconds;
    constructor(toastService: BootstrapToastService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onClose(): void;
    onRemove(): void;
    onStartProgressBar(): void;
    private _setElapsedMinutes;
}
